<?php

namespace VendorFPF\WPDesk\Plugin\Flow\Initialization;

/**
 * Helps with plugin building concepts.
 * Add activation hook.
 *
 * @package WPDesk\Plugin\Flow\Initialization
 */
trait ActivationTrait
{
    /**
     * Initialize activated_plugin action.
     * Action stores plugin activation date.
     *
     * @param string $plugin_file_name
     */
    private function add_activation_hook($plugin_file_name)
    {
        \add_action('activated_plugin', static function ($plugin) {
            $option_name = 'plugin_activation_' . $plugin;
            $activation_date = \get_option($option_name, '');
            if ('' === $activation_date) {
                $activation_date = \current_time('mysql');
                \update_option($option_name, $activation_date);
            }
        });
    }
}
